/*----------------------------------------------------------
	TetrisField.java
	CF09/01/31
	tB[hǗNX
	CNX̖߂ŃubN̑Ȃǂs
----------------------------------------------------------*/
import java.awt.*;
import java.awt.event.*;

class TetrisField {
	private TetrisBlock blc = new TetrisBlock();
	private int [][] field = new int[HEIGHT][WIDTH];	//Q[tB[h
	//萔
	static final int CANVAS_HEIGHT = 600, CANVAS_WIDTH = 350;
	static final int WALL = -1, SPACE = 0, BLOCK = 1; 
  	static final int HEIGHT = 20 + 1;	//
  	static final int WIDTH = 10 + 2; 	//
  	static final int BLOCK_SIZE = 25;	//PubN̕`TCY
  	
  	private int blockX = 5, blockY = 0;	//ubN̍W
  	
  	/*-----------------------------------------------
  		RXgN^()
  	-------------------------------------------------*/
  	TetrisField(){
  		resetField();	//tB[hZbg
  		resetBlock();	//ubÑZbg
  	}
  	/*-----------------------------------------------
  		ubN̏
  	-------------------------------------------------*/
  	private void resetBlock(){
  		//ubNW̏
  		blockX = 4;
  		blockY = 0;
  		//ubN̐
  		blc.createBlock();
  	}
  	/*-----------------------------------------------
  		tB[h̏
  	-------------------------------------------------*/
  	private void resetField(){
  		for(int i=0; i<HEIGHT; i++){
  			for(int j=0; j<WIDTH; j++){
  				field[i][j] = SPACE;
  				
  				if(i==HEIGHT-1 || j==0 || j==WIDTH-1){
  					field[i][j] = WALL;
  				}
  			}
  		}
  	}
  	/*-----------------------------------------------
  		Q[̃C(PTCN)
  	-------------------------------------------------*/
  	public boolean gameMain(){
  		//ֈړ
  		if(moveBlock(0, 1) == false){
  			
  			passiveBlock();	//ubNtB[hɌŒ
  			checkLine();		//C`FbNĂΏ
  			resetBlock();		//VubN𐶐
  		}
  		return isGameOver();	//Q[s\`FbN
  	}
  	/*-----------------------------------------------
  		Q[I[o[̃`FbN
  	-------------------------------------------------*/
  	private boolean isGameOver(){
  		for(int i=1; i<WIDTH; i++){
  			if(field[0][i] == BLOCK){
  				return false;	//Q[I[o[
  			}
  		}
  		return true;
  	}
  	/*-----------------------------------------------
  		tB[h̕`
  	-------------------------------------------------*/
  	public void drawField(Graphics g){
  		g.setColor(Color.black);
  		g.fillRect(0, 0, CANVAS_WIDTH, CANVAS_HEIGHT);	//UʂhԂ
  		
  		for(int i=0; i<HEIGHT; i++){
  			for(int j=0; j<WIDTH; j++){
  				switch(field[i][j]){
  					case SPACE:	//(F)
  						g.setColor(Color.black);
  						break;
  					case WALL:	//(DF)
  						g.setColor(Color.gray);
  						break;
  				}
  				g.fillRect(j*BLOCK_SIZE+BLOCK_SIZE, i*BLOCK_SIZE+BLOCK_SIZE*2, BLOCK_SIZE, BLOCK_SIZE);
  				g.setColor(Color.lightGray);
  				g.drawRect(j*BLOCK_SIZE+BLOCK_SIZE, i*BLOCK_SIZE+BLOCK_SIZE*2, BLOCK_SIZE, BLOCK_SIZE);
  			}
  		}
  	}
  	/*-----------------------------------------------
  		ubN̕`
  	-------------------------------------------------*/
  	public void drawBlock(Graphics g){
  		int [][] block = blc.getBlock();//݂̃ubN擾
  		
  		for(int i=blockY; i<blockY+4; i++){
  			for(int j=blockX; j<blockX+4; j++){
  				switch(block[i-blockY][j-blockX]){
  					case BLOCK:	//ubN(F)
  						g.setColor(Color.white);
  						g.fillRect(j*BLOCK_SIZE+BLOCK_SIZE, i*BLOCK_SIZE+BLOCK_SIZE*2, BLOCK_SIZE, BLOCK_SIZE);
  						g.setColor(Color.lightGray);
  						g.drawRect(j*BLOCK_SIZE+BLOCK_SIZE, i*BLOCK_SIZE+BLOCK_SIZE*2, BLOCK_SIZE, BLOCK_SIZE);
  						break;
  				}
  			}
  		}
  	}
  	/*-----------------------------------------------
  		ubŇ
  	-------------------------------------------------*/
  	public void setAction(int keyCode){
  		switch(keyCode){
			case KeyEvent.VK_UP:
				rotateBlock();		//ubN̉]
				break;
			case KeyEvent.VK_DOWN:
				moveBlock(0, 1);	//ֈړ
				break;
			case KeyEvent.VK_LEFT:
				moveBlock(-1, 0);	//ֈړ
				break;
			case KeyEvent.VK_RIGHT:
				moveBlock(1, 0);	//Eֈړ
				break;
			default:
				break;
		}
  	}
  	/*-----------------------------------------------
  		ubN̈ړ
  	-------------------------------------------------*/
  	private boolean moveBlock(int dirX, int dirY){
  		if(isMoveBlock(dirX, dirY)){//ubN̈ړ\
  			blockX += dirX;
  			blockY += dirY;
  			return true;
  		}
  		return false;
  	}
  	/*-----------------------------------------------
  		ubN̈ړ\ǂ
  	-------------------------------------------------*/
  	boolean isMoveBlock(int dirX, int dirY){
  		int[][] block = blc.getBlock();
  		int x = 0, y = 0;
  		
  		for(int i=0; i<4; i++){
  			for(int j=0; j<4; j++){
  				if(block[i][j] == BLOCK){
  					x = j + dirX + blockX;
  					y = i + dirY + blockY;
  					
  					if(field[y][x] != SPACE){
  						return false;	//ړłȂ
  					}
  				}
  			}
  		}
  		return true;
  	}
  	/*-----------------------------------------------
  		ubN̉]
  	-------------------------------------------------*/
  	private boolean rotateBlock(){
  		int[][] block = blc.getRotateBlock();
  		
  		for(int i=0; i<4; i++){
  			for(int j=0; j<4; j++){
  				if(block[i][j] == BLOCK && field[i+blockY][j+blockX] != SPACE){
  					return false;	//]łȂ
  				}
  			}
  		}
  		blc.rotateBlock();	//ubN]
  		return true;
  	}
  	/*-----------------------------------------------
  		ubNtB[hɌŒ肷
  	-------------------------------------------------*/
  	void passiveBlock(){
  		int[][] block = blc.getBlock();
  		
  		for(int i=0; i<4; i++){
  			for(int j=0; j<4; j++){
  				if(block[i][j] == BLOCK){
  					field[i+blockY][j+blockX] = BLOCK;
  				}
  			}
  		}
  	}
  	
  	/*-----------------------------------------------
  		C̃`FbN
  	-------------------------------------------------*/
  	private void checkLine(){
  		boolean flg = true;
  		
  		for(int i=HEIGHT-2; i>0; i--){
  			for(int j=1; j<WIDTH-1;j++){
  				//ԂꍇAfalseԂ
  				if(field[i][j] == SPACE){
  					flg = false;
  				}
  			}
  			if(flg){
  				deleteLine(i);	//Ă郉C폜
  				i++;			//Pi炷
  			}else{
  				flg = true;
  			}
  		}
  	}
  	/*-----------------------------------------------
  		C̍폜
  	-------------------------------------------------*/
  	private void deleteLine(int lineNum){
  		System.out.println("i:"+lineNum);
  		for(int i=lineNum; i>=0; i--){
  			for(int j=1; j<WIDTH-1; j++){
  				if(i==0){	//ŏi͋󔒂
  					field[i][j] = SPACE;
  				}else{
  					field[i][j] = field[i-1][j]; 
  				}
  			}
  		}
  	}
}